#include <sqlext.h>
#include <ch.h>

EXPORTCH SQLRETURN SQL_API SQLDriverConnect_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLHWND hwnd;
    SQLCHAR *szConnStrIn;
    SQLSMALLINT cbConnStrIn;
    SQLCHAR *szConnStrOut;
    SQLSMALLINT cbConnStrOutMax;
    SQLSMALLINT *pcbConnStrOut;
    SQLUSMALLINT fDriverCompletion;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    hwnd = Ch_VaArg(interp, ap, SQLHWND);
    szConnStrIn = Ch_VaArg(interp, ap, SQLCHAR *);
    cbConnStrIn = Ch_VaArg(interp, ap, SQLSMALLINT);
    szConnStrOut = Ch_VaArg(interp, ap, SQLCHAR *);
    cbConnStrOutMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbConnStrOut = Ch_VaArg(interp, ap, SQLSMALLINT *);
    fDriverCompletion = Ch_VaArg(interp, ap, SQLUSMALLINT);
    retval = SQLDriverConnect(hdbc, hwnd, szConnStrIn, cbConnStrIn, szConnStrOut, cbConnStrOutMax, pcbConnStrOut, fDriverCompletion);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLBrowseConnect_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLCHAR *szConnStrIn;
    SQLSMALLINT cbConnStrIn;
    SQLCHAR *szConnStrOut;
    SQLSMALLINT cbConnStrOutMax;
    SQLSMALLINT *pcbConnStrOut;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    szConnStrIn = Ch_VaArg(interp, ap, SQLCHAR *);
    cbConnStrIn = Ch_VaArg(interp, ap, SQLSMALLINT);
    szConnStrOut = Ch_VaArg(interp, ap, SQLCHAR *);
    cbConnStrOutMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbConnStrOut = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLBrowseConnect(hdbc, szConnStrIn, cbConnStrIn, szConnStrOut, cbConnStrOutMax, pcbConnStrOut);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLBulkOperations_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLSMALLINT Operation;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    Operation = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLBulkOperations(StatementHandle, Operation);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLColAttributes_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLUSMALLINT icol;
    SQLUSMALLINT fDescType;
    SQLPOINTER rgbDesc;
    SQLSMALLINT cbDescMax;
    SQLSMALLINT *pcbDesc;
    SQLLEN *pfDesc;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    icol = Ch_VaArg(interp, ap, SQLUSMALLINT);
    fDescType = Ch_VaArg(interp, ap, SQLUSMALLINT);
    rgbDesc = Ch_VaArg(interp, ap, SQLPOINTER);
    cbDescMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbDesc = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pfDesc = Ch_VaArg(interp, ap, SQLLEN *);
    retval = SQLColAttributes(hstmt, icol, fDescType, rgbDesc, cbDescMax, pcbDesc, pfDesc);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLColumnPrivileges_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLCHAR *szTableName;
    SQLSMALLINT cbTableName;
    SQLCHAR *szColumnName;
    SQLSMALLINT cbColumnName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szColumnName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbColumnName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLColumnPrivileges(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName, szColumnName, cbColumnName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLDescribeParam_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLUSMALLINT ipar;
    SQLSMALLINT *pfSqlType;
    SQLULEN *pcbParamDef;
    SQLSMALLINT *pibScale;
    SQLSMALLINT *pfNullable;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    ipar = Ch_VaArg(interp, ap, SQLUSMALLINT);
    pfSqlType = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pcbParamDef = Ch_VaArg(interp, ap, SQLULEN *);
    pibScale = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pfNullable = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLDescribeParam(hstmt, ipar, pfSqlType, pcbParamDef, pibScale, pfNullable);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLExtendedFetch_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLUSMALLINT fFetchType;
    SQLLEN irow;
    SQLULEN *pcrow;
    SQLUSMALLINT *rgfRowStatus;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    fFetchType = Ch_VaArg(interp, ap, SQLUSMALLINT);
    irow = Ch_VaArg(interp, ap, SQLLEN);
    pcrow = Ch_VaArg(interp, ap, SQLULEN *);
    rgfRowStatus = Ch_VaArg(interp, ap, SQLUSMALLINT *);
    retval = SQLExtendedFetch(hstmt, fFetchType, irow, pcrow, rgfRowStatus);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLForeignKeys_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szPkCatalogName;
    SQLSMALLINT cbPkCatalogName;
    SQLCHAR *szPkSchemaName;
    SQLSMALLINT cbPkSchemaName;
    SQLCHAR *szPkTableName;
    SQLSMALLINT cbPkTableName;
    SQLCHAR *szFkCatalogName;
    SQLSMALLINT cbFkCatalogName;
    SQLCHAR *szFkSchemaName;
    SQLSMALLINT cbFkSchemaName;
    SQLCHAR *szFkTableName;
    SQLSMALLINT cbFkTableName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szPkCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbPkCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szPkSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbPkSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szPkTableName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbPkTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szFkCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbFkCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szFkSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbFkSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szFkTableName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbFkTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLForeignKeys(hstmt, szPkCatalogName, cbPkCatalogName, szPkSchemaName, cbPkSchemaName, szPkTableName, cbPkTableName, szFkCatalogName, cbFkCatalogName, szFkSchemaName, cbFkSchemaName, szFkTableName, cbFkTableName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLMoreResults_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    retval = SQLMoreResults(hstmt);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLNativeSql_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLCHAR *szSqlStrIn;
    SQLINTEGER cbSqlStrIn;
    SQLCHAR *szSqlStr;
    SQLINTEGER cbSqlStrMax;
    SQLINTEGER *pcbSqlStr;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    szSqlStrIn = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSqlStrIn = Ch_VaArg(interp, ap, SQLINTEGER);
    szSqlStr = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSqlStrMax = Ch_VaArg(interp, ap, SQLINTEGER);
    pcbSqlStr = Ch_VaArg(interp, ap, SQLINTEGER *);
    retval = SQLNativeSql(hdbc, szSqlStrIn, cbSqlStrIn, szSqlStr, cbSqlStrMax, pcbSqlStr);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLNumParams_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLSMALLINT *pcpar;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    pcpar = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLNumParams(hstmt, pcpar);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLParamOptions_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLULEN crow;
    SQLULEN *pirow;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    crow = Ch_VaArg(interp, ap, SQLULEN);
    pirow = Ch_VaArg(interp, ap, SQLULEN *);
    retval = SQLParamOptions(hstmt, crow, pirow);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLPrimaryKeys_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLCHAR *szTableName;
    SQLSMALLINT cbTableName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLPrimaryKeys(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLProcedureColumns_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLCHAR *szProcName;
    SQLSMALLINT cbProcName;
    SQLCHAR *szColumnName;
    SQLSMALLINT cbColumnName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szProcName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbProcName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szColumnName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbColumnName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLProcedureColumns(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szProcName, cbProcName, szColumnName, cbColumnName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLProcedures_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLCHAR *szProcName;
    SQLSMALLINT cbProcName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szProcName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbProcName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLProcedures(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szProcName, cbProcName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetPos_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLSETPOSIROW irow;
    SQLUSMALLINT fOption;
    SQLUSMALLINT fLock;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    irow = Ch_VaArg(interp, ap, SQLSETPOSIROW);
    fOption = Ch_VaArg(interp, ap, SQLUSMALLINT);
    fLock = Ch_VaArg(interp, ap, SQLUSMALLINT);
    retval = SQLSetPos(hstmt, irow, fOption, fLock);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLTablePrivileges_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLCHAR *szTableName;
    SQLSMALLINT cbTableName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLTablePrivileges(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLDrivers_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHENV henv;
    SQLUSMALLINT fDirection;
    SQLCHAR *szDriverDesc;
    SQLSMALLINT cbDriverDescMax;
    SQLSMALLINT *pcbDriverDesc;
    SQLCHAR *szDriverAttributes;
    SQLSMALLINT cbDrvrAttrMax;
    SQLSMALLINT *pcbDrvrAttr;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    henv = Ch_VaArg(interp, ap, SQLHENV);
    fDirection = Ch_VaArg(interp, ap, SQLUSMALLINT);
    szDriverDesc = Ch_VaArg(interp, ap, SQLCHAR *);
    cbDriverDescMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbDriverDesc = Ch_VaArg(interp, ap, SQLSMALLINT *);
    szDriverAttributes = Ch_VaArg(interp, ap, SQLCHAR *);
    cbDrvrAttrMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbDrvrAttr = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLDrivers(henv, fDirection, szDriverDesc, cbDriverDescMax, pcbDriverDesc, szDriverAttributes, cbDrvrAttrMax, pcbDrvrAttr);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLBindParameter_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLUSMALLINT ipar;
    SQLSMALLINT fParamType;
    SQLSMALLINT fCType;
    SQLSMALLINT fSqlType;
    SQLULEN cbColDef;
    SQLSMALLINT ibScale;
    SQLPOINTER rgbValue;
    SQLLEN cbValueMax;
    SQLLEN *pcbValue;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    ipar = Ch_VaArg(interp, ap, SQLUSMALLINT);
    fParamType = Ch_VaArg(interp, ap, SQLSMALLINT);
    fCType = Ch_VaArg(interp, ap, SQLSMALLINT);
    fSqlType = Ch_VaArg(interp, ap, SQLSMALLINT);
    cbColDef = Ch_VaArg(interp, ap, SQLULEN);
    ibScale = Ch_VaArg(interp, ap, SQLSMALLINT);
    rgbValue = Ch_VaArg(interp, ap, SQLPOINTER);
    cbValueMax = Ch_VaArg(interp, ap, SQLLEN);
    pcbValue = Ch_VaArg(interp, ap, SQLLEN *);
    retval = SQLBindParameter(hstmt, ipar, fParamType, fCType, fSqlType, cbColDef, ibScale, rgbValue, cbValueMax, pcbValue);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLAllocHandleStd_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLSMALLINT fHandleType;
    SQLHANDLE hInput;
    SQLHANDLE *phOutput;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    fHandleType = Ch_VaArg(interp, ap, SQLSMALLINT);
    hInput = Ch_VaArg(interp, ap, SQLHANDLE);
    phOutput = Ch_VaArg(interp, ap, SQLHANDLE *);
    retval = SQLAllocHandleStd(fHandleType, hInput, phOutput);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetScrollOptions_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLUSMALLINT fConcurrency;
    SQLLEN crowKeyset;
    SQLUSMALLINT crowRowset;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    fConcurrency = Ch_VaArg(interp, ap, SQLUSMALLINT);
    crowKeyset = Ch_VaArg(interp, ap, SQLLEN);
    crowRowset = Ch_VaArg(interp, ap, SQLUSMALLINT);
    retval = SQLSetScrollOptions(hstmt, fConcurrency, crowKeyset, crowRowset);
    Ch_VaEnd(interp, ap);
    return retval;
}
